/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Manager_STUB_HPP_
#define V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Manager_STUB_HPP_

#include <functional>
#include <sstream>



#include <v1/commonapi/telux/common/CommonDefines.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypes.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesStub.hpp>

#include <v1/commonapi/telux/cv2x/Cv2xRadioManager.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/Deployment.hpp>
#include <CommonAPI/InputStream.hpp>
#include <CommonAPI/OutputStream.hpp>
#include <CommonAPI/Struct.hpp>
#include <cstdint>
#include <unordered_set>
#include <vector>


#include <CommonAPI/Stub.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace cv2x {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service Cv2xRadioManager. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class Cv2xRadioManagerStubAdapter
    : public virtual CommonAPI::StubAdapter,
      public virtual Cv2xRadioManager,
      public virtual ::v1::commonapi::telux::cv2x::Cv2xRadioTypesStubAdapter {
 public:
    /**
    * Sends a broadcast event for currentCv2xStatus. Should not be called directly.
    * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
    */
    virtual void fireCurrentCv2xStatusEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus &_status) = 0;


    virtual void deactivateManagedInstances() = 0;


protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */

};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for Cv2xRadioManager.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class Cv2xRadioManagerStubRemoteEvent
: public virtual ::v1::commonapi::telux::cv2x::Cv2xRadioTypesStubRemoteEvent
{
public:
    virtual ~Cv2xRadioManagerStubRemoteEvent() { }

};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service Cv2xRadioManager to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class Cv2xRadioManagerStub
    : public virtual CommonAPI::Stub<Cv2xRadioManagerStubAdapter, Cv2xRadioManagerStubRemoteEvent>,
      public virtual ::v1::commonapi::telux::cv2x::Cv2xRadioTypesStub
{
public:
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error, ::v1::commonapi::telux::common::CommonDefines::ServiceStatus _status)> GetServiceStatusReply_t;
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error, ::v1::commonapi::telux::common::CommonDefines::Status _status)> startCv2xReply_t;
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error, ::v1::commonapi::telux::common::CommonDefines::Status _status)> stopCv2xReply_t;
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus _status)> requestCv2xStatusReply_t;
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatusEx _statusEx)> requestCv2xStatusExReply_t;

    virtual ~Cv2xRadioManagerStub() {}
    void lockInterfaceVersionAttribute(bool _lockAccess) { static_cast<void>(_lockAccess); }
    bool hasElement(const uint32_t _id) const {
        return (_id < 6);
    }
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client) = 0;

    /// This is the method that will be called on remote calls on the method GetServiceStatus.
    virtual void GetServiceStatus(const std::shared_ptr<CommonAPI::ClientId> _client, GetServiceStatusReply_t _reply) = 0;
    /// Sends a broadcast event for currentCv2xStatus.
    virtual void fireCurrentCv2xStatusEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus &_status) {
        auto stubAdapter = CommonAPI::Stub<Cv2xRadioManagerStubAdapter, Cv2xRadioManagerStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireCurrentCv2xStatusEvent(_status);
    }
    /// This is the method that will be called on remote calls on the method startCv2x.
    virtual void startCv2x(const std::shared_ptr<CommonAPI::ClientId> _client, startCv2xReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method stopCv2x.
    virtual void stopCv2x(const std::shared_ptr<CommonAPI::ClientId> _client, stopCv2xReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method requestCv2xStatus.
    virtual void requestCv2xStatus(const std::shared_ptr<CommonAPI::ClientId> _client, requestCv2xStatusReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method requestCv2xStatusEx.
    virtual void requestCv2xStatusEx(const std::shared_ptr<CommonAPI::ClientId> _client, requestCv2xStatusExReply_t _reply) = 0;


    using CommonAPI::Stub<Cv2xRadioManagerStubAdapter, Cv2xRadioManagerStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<Cv2xRadioManagerStubAdapter, Cv2xRadioManagerStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<Cv2xRadioManagerStubAdapter, Cv2xRadioManagerStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef Cv2xRadioManagerStubRemoteEvent RemoteEventType;
    typedef Cv2xRadioManager StubInterface;
};

} // namespace cv2x
} // namespace telux
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Manager_STUB_HPP_
